var debug;
var GeneralOptionsObj ={
    init: function(){
        GeneralOptionsObj.initSettings();
        GeneralOptionsObj.addEvents();
    },
    initSettings: function(){
        settingsObj
        .getSettings()
        .then(response => {
            GeneralOptionsObj.uiSettings = response.uiSettings;
            debug = GeneralOptionsObj.uiSettings.Log_Flag;
                // Start general settings
                var general_settings_div = $('.general_settings');
                var general_settings = GeneralOptionsObj.uiSettings.general_settings;
                var paw_settings = GeneralOptionsObj.uiSettings;

                /*new settings*/
                var mail_provider=general_settings["email_provider"];
                //$("#label-icon-mail").text(general_settings["email_provider_name"]);
                $("#label-icon-mail").attr('email_provider_name',general_settings["email_provider_name"]);
                general_settings["email_provider_name"]!='default'?$("#"+mail_provider).prop('checked',true):'';
              /*  $("#label-icon-mail").closest('li').attr('data-original-title','Open '+general_settings["email_provider_name"]); */               
                $("#label-icon-mail").closest('li').attr('data-original-title','Open Email'); 

                var calendar_provider=general_settings["calendar_provider"];
                $("#label-icon-calendar").attr('calendar_provider_name',general_settings["calendar_provider_name"]);
                general_settings["calendar_provider_name"]!='default'?$("#"+calendar_provider).prop('checked',true):'';
                //$("#"+calendar_provider).prop('checked',true);
                /*$("#label-icon-calendar").closest('li').attr('data-original-title','Open '+general_settings["calendar_provider_name"])*/
                $("#label-icon-calendar").closest('li').attr('data-original-title','Open Calendar')
                $('#your-name-input').val(general_settings["greeting_msg"]);
                if (general_settings["greeting_msg"]!=='') {
                var name_screen='Hello '+general_settings["greeting_msg"]+'!'
                $('p.greeting_msg').text(name_screen);
                general_settings["hide_email"]?$('#Do-Mail').hide():$('#Do-Mail').show();
                general_settings["hide_calendar"]?$('#Do-calendar').hide():$('#Do-calendar').show();
                } 
                general_settings["hide_email"]?$('#Do-Mail').hide():$('#Do-Mail').show();
                general_settings["hide_calendar"]?$('#Do-calendar').hide():$('#Do-calendar').show();
                /*end*/

                for (setting_key in general_settings) {
                    var setting_val = general_settings[setting_key];
                    $(general_settings_div).find("#"+setting_key).prop('checked',setting_val);
                }

                if (general_settings["temperature"] == true) {
                    $(".show-weather").css("display","inline-block");
                } else {
                    $(".show-weather").hide();
                }
                if (general_settings["location"] == true) {
                    $(".wallpaper-bg-location-text").show();
                } else {
                    $(".wallpaper-bg-location-text").hide();
                }
                if (general_settings["clock"] == true) {
                    $(".timer").css("display","inline-block");
                    //$(".timer").html("salman");
                } else {
                    $(".timer").hide();
                }

                var timeType = general_settings.timeType;
                $(general_settings_div).find('.active').removeClass("active");
                $(general_settings_div).find('input[value="'+timeType+'"]').parent().addClass("active");
                var ampmSelected = moment().format('A');
                SetTIime(timeType,ampmSelected);

                for (var i = 0; i < mySettingPage.timeInterval_arr.length; i++) {
                    clearInterval(mySettingPage.timeInterval_arr[i]);
                }
                if (general_settings["clock"] == true) {
                    var timeInterval = setInterval(function() {
                        SetTIime(timeType,ampmSelected);
                    }, 1000);
                    mySettingPage.timeInterval_arr.push(timeInterval);
                }
                // End general settings
            })
        .catch(console.error);

    },
    addEvents: function(){
        $('#your-name-input').keypress(function (e) {
           var key = e.which;
           if(key == 13)  
           {
            $('#your-name-input').blur();
            return false;  
        }
    });  

        $('#your-name-input').blur(function() {
            var name=$(this).val();
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                var savedName=GeneralOptionsObj.uiSettings.general_settings['greeting_msg'];
                GeneralOptionsObj.uiSettings.general_settings['greeting_msg'] = name;
                if (name!=savedName) {
                    settingsObj
                    .save({uiSettings: GeneralOptionsObj.uiSettings})
                    .then(saveResponse => {
                        GeneralOptionsObj.uiSettings = saveResponse.uiSettings;
                        $('#save-msg-name').show();
                        setTimeout(function(){
                            $('#save-msg-name').hide();
                        },2000)
                        GeneralOptionsObj.initSettings(false);
                    })
                    .catch(console.error);
                }
            })
            .catch(console.error);

        });
        $(document).on('click','#Do-calendar',function(){
            var calendar=$(this).find('#label-icon-calendar').attr('calendar_provider_name').trim();;
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                var calendar_provider_arr=GeneralOptionsObj.uiSettings.calendar_provider_arr;
                 if (calendar == 'default') {
                    $('[href="#settings_tab_calendar"]').click();
                    $('#settings-pop').modal('show');
                    return false;
                }
                for (var i = 0; i < calendar_provider_arr.length; i++) {
                    if (calendar_provider_arr[i]['name']==calendar) {
                        chrome.tabs.create({"url":calendar_provider_arr[i]['url'],"selected":true},function(tab){ });
                        break;
                    } 
                }

            })
            .catch(console.error);
        });

        $(document).on('change','#bg_animations',function(){
            var animateVal=$(this).val();
            localStorage.setItem("bg_animation",animateVal);
            setBackgroundAnimation();
        });


        $(document).on('click','#Do-Mail',function(){
            //var email=$(this).find('#label-icon-mail').text().trim();
            var email=$(this).find('#label-icon-mail').attr('email_provider_name').trim();
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                var email_provider_arr=GeneralOptionsObj.uiSettings.email_provider_arr;
                if (email == 'default') {
                    $('[href="#settings_tab_email"]').click();
                    $('#settings-pop').modal('show');
                    return false;
                }
                for (var i = 0; i < email_provider_arr.length; i++) {
                    if (email_provider_arr[i]['name']==email) {
                        chrome.tabs.create({"url":email_provider_arr[i]['url'],"selected":true},function(tab){ });
                        break;
                    } 
                }

            })
            .catch(console.error);
        });


        $(document).on('change','input[name="calendar_provider"]',function(){
            var checkbox_elem = $(this);
            var provuder_name=$(this).next().text().trim();
            var hide_calendar=false;
            if (provuder_name=='None') {
                $('#Do-calendar').hide();
                hide_calendar=true;
            }else{
                $('#Do-calendar').show();
            } 
            var checked = $(checkbox_elem).is(':checked');
            var setting_id = $(checkbox_elem).attr('id');
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                if (hide_calendar) {
                 GeneralOptionsObj.uiSettings.general_settings['hide_calendar'] = true;   
                } else {
                 GeneralOptionsObj.uiSettings.general_settings['hide_calendar'] = false;   

                }
                GeneralOptionsObj.uiSettings.general_settings['calendar_provider'] = setting_id;
                GeneralOptionsObj.uiSettings.general_settings['calendar_provider_name'] = provuder_name =='Google' ? 'Calendar' :provuder_name;

                settingsObj
                .save({uiSettings: GeneralOptionsObj.uiSettings})
                .then(saveResponse => {
                    GeneralOptionsObj.uiSettings = saveResponse.uiSettings;
                    GeneralOptionsObj.initSettings(false);
                })
                .catch(console.error);
            })
            .catch(console.error);
        });

        $(document).on('change','input[name="email_provider"]',function(){
            var checkbox_elem = $(this);
            var provuder_name=$(this).next().text().trim();
            var hide_email=false;
            if (provuder_name=='None') {
                $('#Do-Mail').hide();
                hide_email=true;
            }else{
                $('#Do-Mail').show();
            } 
            var checked = $(checkbox_elem).is(':checked');
            var setting_id = $(checkbox_elem).attr('id');
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                if (hide_email) {
                 GeneralOptionsObj.uiSettings.general_settings['hide_email'] = true;   
                } else {
                 GeneralOptionsObj.uiSettings.general_settings['hide_email'] = false;   

                }
                GeneralOptionsObj.uiSettings.general_settings['email_provider'] = setting_id;
                GeneralOptionsObj.uiSettings.general_settings['email_provider_name'] = provuder_name == 'Gmail' ? 'Email' : provuder_name;

                settingsObj
                .save({uiSettings: GeneralOptionsObj.uiSettings})
                .then(saveResponse => {
                    GeneralOptionsObj.uiSettings = saveResponse.uiSettings;
                    GeneralOptionsObj.initSettings(false);
                })
                .catch(console.error);
            })
            .catch(console.error);
        });

        $(document).on('dblclick','.current-time',function(){
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                var timeType =  GeneralOptionsObj.uiSettings.general_settings.timeType;
                if (timeType == "h:mm") {
                    timeType = "HH:mm";
                    $('#timeType').find('input[value="HH:mm"]').click();
                } else if (timeType == "HH:mm") {
                    timeType = "h:mm";
                    $('#timeType').find('input[value="h:mm"]').click();
                }
                GeneralOptionsObj.uiSettings.general_settings.timeType = timeType;

                settingsObj
                .save({uiSettings: GeneralOptionsObj.uiSettings})
                .then(saveResponse => {
                    GeneralOptionsObj.uiSettings = saveResponse.uiSettings;
                    GeneralOptionsObj.initSettings(false);
                })
                .catch(console.error);
            })
            .catch(console.error);
        });

        $(document).on('click', '#timeType [role="button"]', function (e) {
            var timeType = $(this).find("input").val();
            $("#timeType").find('.active').removeClass("active");
            $(this).addClass("active");
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                GeneralOptionsObj.uiSettings.general_settings.timeType = timeType;
                settingsObj
                .save({uiSettings: GeneralOptionsObj.uiSettings})
                .then(saveResponse => {
                    GeneralOptionsObj.uiSettings = saveResponse.uiSettings;
                    GeneralOptionsObj.initSettings(false);
                })
                .catch(console.error);
            })
            .catch(console.error);
        });

        $(document).on('change','.general_settings input[type="checkbox"]',function(){
            var checkbox_elem = $(this);
            var checked = $(checkbox_elem).is(':checked');
            var setting_id = $(checkbox_elem).attr('id');
            settingsObj
            .getSettings()
            .then(response => {
                GeneralOptionsObj.uiSettings = response.uiSettings;
                GeneralOptionsObj.uiSettings.general_settings[setting_id] = checked;
                settingsObj
                .save({uiSettings: GeneralOptionsObj.uiSettings})
                .then(saveResponse => {
                    GeneralOptionsObj.uiSettings = saveResponse.uiSettings;
                    GeneralOptionsObj.initSettings(false);
                })
                .catch(console.error);
            })
            .catch(console.error);
        });


    }
};

function SetTIime(timeType,ampmSelected){
    $(".timer .current-time").text(moment().format(timeType));
    if (timeType != "HH:mm") {
        $(".timer .time-format").text(ampmSelected);
    } else {
        $(".timer .time-format").text("");
    }
}
function logMode(message) {
  if (debug) { 
    console.log(message);
}
}



