var db;
var Gl_LastImage;
window.addEventListener("load",function() {
  chrome.runtime.onMessage.addListener(handleMessage);
  mySettingPage.load();
});
function getColorForBackground(hex) {
  let tmp = (parseInt(hex.substring(0, 2), 16) + parseInt(hex.substring(2, 4), 16) + parseInt(hex.substring(4, 6), 16)) / 3;
  let color = "#000000";
  if (tmp < 128) {
    color = "#ffffff";
  }
  return color;
}

var uiSettings;
var mySettingPage = {
  timeInterval_arr:[],
  uiSettings: {},
  load: function(){
    var uiSettings_obj = localStorage['uiSettings'];
    if (typeof(uiSettings_obj) != "undefined" && uiSettings_obj != undefined) {
      uiSettings_obj = JSON.parse(uiSettings_obj);
      var last_bg_b64_img = uiSettings_obj.last_bg_b64_img;
      var last_img = uiSettings_obj.background_settings.choose_background_wallpaper.UPDATE_INTERVAL_last_img;
      var last_color = uiSettings_obj.background_settings.choose_background_wallpaper.UPDATE_INTERVAL_last_img;
      var last_option = uiSettings_obj.background_settings.choose_background_wallpaper.UPDATE_INTERVAL_last_img;
      var BlobKey=uiSettings_obj.BlobKey;
      var choose_background = uiSettings_obj.background_settings.choose_background;
      if (choose_background == "Wallpaper") {
        if (typeof(last_bg_b64_img) != "undefined" && last_bg_b64_img != undefined && last_bg_b64_img != "") {
          $(".appliance-sections").addClass("fadeInClass");
          $(".appliance-sections").css('opacity',0.5);
          $(".appliance-sections").css('background-image', 'url('+last_bg_b64_img+')');
           //$(".appliance-sections").removeClass("fadeInClass");
           setTimeout(function(){
            $(".appliance-sections").removeClass("fadeInClass");
            $(".appliance-sections").css('opacity',1);
          },10)
         } else {
          if (BlobKey!='IsImage' && BlobKey!='' ) {
           mySettingPage.InitializeDb().then((res) => {
            mySettingPage.GetImageFromDbForWallpaper(BlobKey,'IMAGES');
          })
         }else{
          if (typeof(last_img) != "undefined" && last_img != undefined && last_img != "") {
            mySettingPage.InitializeDb().then((res) => {
              mySettingPage.GetRandomImageFromOnlineDb(last_img,'IMAGESOnline');
            }) 
          }
        
      }
    }
    
  }
}

mySettingPage.initSettings(true);
mySettingPage.addEvents();
},

InitializeDb:function(json_callback) {
  return new Promise((resolve, reject) => {
   var indexedDB = window.indexedDB || window.webkitIndexedDB || window.mozIndexedDB || window.OIndexedDB || window.msIndexedDB,
   IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.OIDBTransaction || window.msIDBTransaction,
   dbVersion = 1.0;

    // Create/open database
    var request = indexedDB.open("mybookmark", dbVersion),
    createObjectStore = function (dataBase) {
            // Create an objectStore
            logMode("Creating objectStore")
            dataBase.createObjectStore("IMAGES");
          };

          request.onsuccess = function (event) {
            logMode("Success creating/accessing IndexedDB database");
            db = request.result;
            resolve(db);

            db.onerror = function (event) {
              logMode("Error creating/accessing IndexedDB database");
            };
          }
          request.onupgradeneeded = function (event) {
            createObjectStore(event.target.result);
          };

        });
},
SetLOcationDetailS:function(LocationObj) {
  try{
    var artistname_txt=LocationObj.artistname_txt !=undefined?LocationObj.artistname_txt:'';
    var artistname_url=LocationObj.artistname_url!=undefined?LocationObj.artistname_url:'';
  }catch{
    var artistname_txt='';
  }
  try{
    var location_txt=LocationObj.location_txt!=undefined?LocationObj.location_txt:'';
    var location_url=LocationObj.location_url!=undefined?LocationObj.location_url:'';
  }catch{
    var location_txt='';
  }

  

  if(location_txt!="") {
    $('.wallpaper-bg-location-text #wallpaper-bg-location-text').html('<i class="fa fa-map-marker" aria-hidden="true"></i><h4 class="location_txt">'+location_txt+'</h4>');
    $('.wallpaper-bg-location-text #wallpaper-bg-location-text').attr('data-url',location_url);
    if(location_url=="") {
      $('.wallpaper-bg-location-text #wallpaper-bg-location-text h4').css('text-decoration','none !important');
    }
  }
  if(artistname_txt!="") {
    $('.wallpaper-bg-location-text #Artist-info').html('<i class="fa fa-camera" aria-hidden="true"></i><h4 class="artistname_txt">by '+artistname_txt+'</h4>');
    $('.wallpaper-bg-location-text #Artist-info').attr('data-url',artistname_url);

  } 
  var IsAnchor=$('.wallpaper-bg-location-text h4.artistname_txt').closest('span').attr('data-url');
  if (IsAnchor!=undefined || IsAnchor!='') {
    $('.wallpaper-bg-location-text h4.artistname_txt').css('text-decoration','none !important');
  }
},
GetRandomImageFromOnlineDb:function(keyVal,store){
 var readWriteMode = typeof IDBTransaction.READ_WRITE == "undefined" ? "readwrite" : IDBTransaction.READ_WRITE;
 var transaction = db.transaction(["IMAGESOnline"], readWriteMode);
 transaction.objectStore("IMAGESOnline").get(parseInt(keyVal)).onsuccess = function (event) {
  mySettingPage.SetLOcationDetailS(event.target.result);
  var imgFile = event.target.result.blob;
  var URL = window.URL || window.webkitURL;
  var outputImage = URL.createObjectURL(imgFile);
  if (outputImage!=''){
    $(".appliance-sections").addClass("fadeInClass");
    $(".appliance-sections").css('opacity',0.5);
    $(".appliance-sections").css('background-image', 'url('+outputImage+')');
           //$(".appliance-sections").removeClass("fadeInClass");
           setTimeout(function(){
            $(".appliance-sections").removeClass("fadeInClass");
            $(".appliance-sections").css('opacity',1);
          },10)

         }

       }

     },

     GetImageFromDbForWallpaper:function(blob,store){
       var readWriteMode = typeof IDBTransaction.READ_WRITE == "undefined" ? "readwrite" : IDBTransaction.READ_WRITE;
       var transaction = db.transaction([store], readWriteMode);
       transaction.objectStore(store).get(blob).onsuccess = function (event) {
         var imgFile = event.target.result;
         var URL = window.URL || window.webkitURL;
         var outputImage = URL.createObjectURL(imgFile);
         if (outputImage!=''){
          $(".appliance-sections").addClass("fadeInClass");
          $(".appliance-sections").css('opacity',0.5);
          $(".appliance-sections").css('background-image', 'url('+outputImage+')');
           //$(".appliance-sections").removeClass("fadeInClass");
           setTimeout(function(){
            $(".appliance-sections").removeClass("fadeInClass");
            $(".appliance-sections").css('opacity',1);
          },10)

         }
       }

     },
     initSettings: function(change_Bg){
    //GeneralOptionsObj.init();
        // debugger
        $("#top_color, #bottom_color, #background_color").each(function() {
          let self = this;
          $(self).ColorPicker({
            "eventName": "focus",
            "color": "f3f3f3",
            "onChange": function (hsb, hex, rgb) {
              $(self).val('#' + hex);
              $(self).css({
                "backgroundColor": "#" + hex,
                "color": getColorForBackground(hex)
              });

            },
            "onSubmit": function(hsb, hex, rgb, el) {
              $(el).ColorPickerHide()
            }
          }).bind('keyup change', function(){
            $(this).ColorPickerSetColor(this.value);

          });
        });

        settingsObj
        .getSettings()
        .then(response => {
          mySettingPage.uiSettings = response.uiSettings;
          var extension_version=mySettingPage.uiSettings.extension_version;
          mySettingPage.Change_Ext_Version(extension_version);
          var AlbumBlobs=mySettingPage.uiSettings.background_settings.choose_background_wallpaper.IMAGE_BLOBS;
          var IMAGE_BLOBS_READY=mySettingPage.uiSettings.IMAGE_BLOBS_READY;
          GeneralOptionsObj.init();
          BackgroundOptionsObj.init(change_Bg);
          

        })
        .catch(console.error);
      },

      getHostname:function(href) {
        var aLink = document.createElement("a");
        aLink.href = href;
        return aLink.protocol +"//"+ aLink.hostname;
      },
      Change_Ext_Version:function(version) {
        $('span.extension-version').text(version);
      },
      addEvents: function(){

        $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
            var target = $(e.target).attr("href") // activated tab
            if ((target == '#paw_tab2')) {
              $('#filetitle').click();
            }
          });

        $(document).on('click', '#wallpaper-bg-location-text', function(e){
          e.preventDefault();
          let url = $(this).attr("data-url");
          if (url!='') {
            chrome.tabs.create({url: url});
          }else{
            return false;
          }

        });
        $(document).on('click', '#Artist-info', function(e){
          e.preventDefault();
          let url = $(this).attr("data-url");
          if (url!='') {
            chrome.tabs.create({url: url});
          }else{
            return false;
          }

        });
      },
    };

    var callback=[];
    function sendMessage(msg, callbackfn) {
      if(callbackfn!=null) {
        callback.push(callbackfn);
        msg.callback = "yes";
      }
      chrome.runtime.sendMessage(msg,callbackfn);
    }

    function handleMessage(message, sender) {
      switch (message.command) {
        case "rec_getSettings":
        mySettingPage.uiSettings  = message.data.uiSettings;
        mySettingPage.smsSettings = message.data.smsSettings;
        break;
        case "change_show_paw_stamp_checkbox":
        var paw_settings_div = $('#paw-settings');
        var showPawStamp_Val = message.data;
        if (typeof(showPawStamp_Val)!='undefined') {
          $(paw_settings_div).find("#showPawStamp").prop('checked',showPawStamp_Val);
        }        
        break;
      }
      if(typeof(message.data)!="undefined") {
        if(typeof(message.callback)!="undefined" && message.callback=="yes") {
          var fun = callback.pop();
        }
      }
    }


