var INDEX;
window.addEventListener("load",function() {
    chrome.runtime.onMessage.addListener(handleMessage);
    myTodo.load();
    myTodo.addEvents();

});
var uiSettings;
var myTodo = {
    uiSettings: {},
    load: function(){
     settingsObj.getSettings().then(response => {
       myTodo.uiSettings = response.uiSettings;
       var listItems=myTodo.uiSettings.listItems;
       var IsActiveToDo=myTodo.uiSettings.IsActiveToDo;
       
       if (IsActiveToDo==false || IsActiveToDo==null) {
        $('.settings-settings-todo-wrapper-section-section').hide();  
    }else{
        $('.settings-settings-todo-wrapper-section-section').show();  
    }
    myTodo.showTodoList(listItems);
});     
 },

 showTodoList:function(data){
    var Todo_arr = data;
    var table_list_html='';
    for (var i = 0; i < Todo_arr.length; i++){
        var classCompleted='';
        var todo_item = Todo_arr[i]['todo_item'];
        var active = Todo_arr[i]['active'];
        if (active) {
          classCompleted='completed'
      }
      
      table_list_html +="<li class="+classCompleted+"><input class='checkbox' data-id="+i+" id='todo-checkbox-" + parseInt(i+1) + "' type='checkbox' "+(active == true ? "checked" : "")+"/><label for='todo-checkbox-" + parseInt(i+1) + "'>" + todo_item + "</label><a class='remove'><i class='fa fa-times-circle'></i></a></li>"

  }
  if (Todo_arr.length == 0) {
    $('.settings-nothing-todo-section').show();
}else{
   $('.settings-nothing-todo-section').hide();
   $('#list-items').html(table_list_html);
}
Setsttings_todo_header_count();

},

addEvents: function(){
    $('.add-items').submit(function(event) 
    {

        event.preventDefault();
        settingsObj.getSettings(true).then(response => {
            myTodo.uiSettings = response.uiSettings;
            var listItems=myTodo.uiSettings.listItems;
            var item = $('#todo-list-item').val();
            if (item!='') {
              var Todo_data = {
                  "todo_item" :item
              };

              Todo_data.active = false;
              myTodo.uiSettings.listItems.push(Todo_data);

              settingsObj
              .save({uiSettings: myTodo.uiSettings})
              .then(saveResponse => {
                myTodo.uiSettings = response.uiSettings;
                var listItems=myTodo.uiSettings.listItems;

                $('#todo-list-item').val("");
                myTodo.showTodoList(listItems);

            })
              .catch(console.error);
          } 

          

      }); 
        
    });

    $(document).on('change', '.checkbox', function() 
    {
        var $_this=$(this);
        settingsObj.getSettings(true).then(response => {
            myTodo.uiSettings = response.uiSettings;
            var listItems=myTodo.uiSettings.listItems;
            var liIndex=myTodo.uiSettings.index;
            var data_id=$($_this).attr('data-id');
            var Ischecked=$($_this).parent().find('input').is(':checked');

            if($($_this).attr('checked')) 
            {
                $($_this).removeAttr('checked');
            } 
            else 
            {
                $($_this).attr('checked', 'checked');
            }

            $($_this).parent().toggleClass('completed');
            myTodo.uiSettings.listItems[data_id].active=Ischecked;
            settingsObj
            .save({uiSettings: myTodo.uiSettings})
            .then(saveResponse => {
                myTodo.uiSettings = response.uiSettings;
                var listItems=myTodo.uiSettings.listItems;
                myTodo.showTodoList(listItems);
            })
            .catch(console.error);

        }); 

    });

    $(document).on('click', '.remove', function() 
    {
        var $_this=$(this);
        settingsObj.getSettings(true).then(response => {
            myTodo.uiSettings = response.uiSettings;
            var listItems=myTodo.uiSettings.listItems;
            var Ischecked=$($_this).parent().find('input').is(':checked');
            var data_id=$($_this).parent().find('input').attr('data-id');
            myTodo.uiSettings.listItems.splice(data_id, 1);
            $($_this).parent().remove();
            settingsObj
            .save({uiSettings: myTodo.uiSettings})
            .then(saveResponse => {
                myTodo.uiSettings = response.uiSettings;
                var listItems=myTodo.uiSettings.listItems;
                myTodo.showTodoList(listItems);

            })
            .catch(console.error);

        }); 


    });

    $(document).on('click', '#sttings-todo-header-cancel', function() 
    {
        var $_this=$(this);
        settingsObj.getSettings(true).then(response => {
            myTodo.uiSettings = response.uiSettings;
            var listItems=myTodo.uiSettings.listItems;
            myTodo.uiSettings.IsActiveToDo=false;
            settingsObj
            .save({uiSettings: myTodo.uiSettings})
            .then(saveResponse => {
                myTodo.uiSettings = response.uiSettings;
                $('.settings-settings-todo-wrapper-section-section').hide();

            })
            .catch(console.error);

        }); 


    });

    $(document).on('click', '.todo-title', function() 
    {
       var $_this=$(this);
       settingsObj.getSettings(true).then(response => {
        myTodo.uiSettings = response.uiSettings;
        var listItems=myTodo.uiSettings.listItems;
        
        var wrapper=$('.settings-settings-todo-wrapper-section-section').css('display');
        if (wrapper=='none') {
            $('.settings-settings-todo-wrapper-section-section').show();
            myTodo.uiSettings.IsActiveToDo=true;
        }else{
            $('.settings-settings-todo-wrapper-section-section').hide();  
            myTodo.uiSettings.IsActiveToDo=false;
        }
        settingsObj
        .save({uiSettings: myTodo.uiSettings})
        .then(saveResponse => {
            myTodo.uiSettings = response.uiSettings;

        })
        .catch(console.error);

    }); 


   });


},
};
function Setsttings_todo_header_count(){
    settingsObj.getSettings(true).then(response => {
       myTodo.uiSettings = response.uiSettings;
       var listItems=myTodo.uiSettings.listItems;
       var dataList=[];
       for (var i = 0; i < listItems.length; i++) {
           if (listItems[i].active==false) {
            dataList.push(listItems[i])
        }
        
    }
    INDEX=dataList.length;
    if (INDEX!=0) {
        $('#sttings-todo-header-count').text('To-Do ('+(parseInt(INDEX))+')')
    }else{
        $('#sttings-todo-header-count').text('To-Do (0)')
    }

}); 

}
var callback=[];
function sendMessage(msg, callbackfn) {
    if(callbackfn!=null) {
        callback.push(callbackfn);
        msg.callback = "yes";
    }
    chrome.runtime.sendMessage(msg,callbackfn);
}

function handleMessage(message, sender) {
    switch (message.command) {
        case "rec_getSettings":
        myTodo.uiSettings  = message.data.uiSettings;
        myTodo.smsSettings = message.data.smsSettings;
        break;
        
    }
    if(typeof(message.data)!="undefined") {
        if(typeof(message.callback)!="undefined" && message.callback=="yes") {
            var fun = callback.pop();
        }
    }
}



