

settingsObj
.getSettings()
.then(getSettings => {
	uiSettings = getSettings.uiSettings;
	var last_update_time=uiSettings.last_update_news;
	var monthly_tips = [];
	var daily_news_arr = uiSettings.daily_news_arr;
	var isUpdateNow = checkValidateLastrecipe(last_update_time);
	if (isUpdateNow) {
		getDailyNewsApi().then((daily_news_arr) => {
			settingsObj
			.getSettings()
			.then(getSettings => {
				uiSettings = getSettings.uiSettings;	
				var daily_arr = [...new Set([...monthly_tips,...daily_news_arr])];
				uiSettings.daily_news_arr = daily_news_arr
				uiSettings.last_update_news = new Date().getTime();
				settingsObj
				.save({uiSettings: uiSettings})
				.then(saveResponse => {
					 console.log('news')
					 console.log(saveResponse.uiSettings)
					createDailyNewsBox(daily_arr)
				})
				.catch(console.error);

			})
			})
		}else{
			var daily_arr = [...new Set([...monthly_tips,...daily_news_arr])];
			createDailyNewsBox(daily_arr)
		}



	})
		.catch(console.error);

		function reorder(arr, index, n) {
			var temp = [...Array(n)];

        // arr[i] should be present at index[i] index
        for (var i = 0; i < n; i++) temp[index[i]] = arr[i];

        // Copy temp[] to arr[]
    for (var i = 0; i < n; i++) {
    	arr[i] = temp[i];
    	index[i] = i;
    }

    return arr;
}



function getDailyNewsApi(json_callback) {
	return new Promise((resolve, reject) => {
		var settings = {
			"url":consts.news_api_url,
			"method": "GET"
		};

		$.ajax(settings).done(function (data) {
			console.log(data)
			if (data.response.results.length !=0 ) {
				var result = getRandom3(data.response.results);
				resolve(result);
			}

		})
		.fail(function(){
			resolve([]);
		})
	});
}

function checkValidateLastrecipe(last_update_time){
	if (last_update_time != undefined && last_update_time !='' ) {
		var currentTime = new Date().getTime();
		if (currentTime - last_update_time >= 1*24*60*60*1000 ) {
			return true;
		}else{
			return false;
		}

	}else{
		return true
	}
}

function getRandom3(res){
	const n = 3;
	var data = res.map(x => ({ x, r: Math.random() }))
	.sort((a, b) => a.r - b.r)
	.map(a => a.x)
	.slice(0, n);

	var newArray=[];
	for (var i = 0; i < data.length; i++) {
		var obj={
			'title':data[i]['webTitle'],
			'url':data[i]['webUrl']
		}
		newArray.push(obj);
	}

	return newArray;
}

function truncateWords(sentence) {
  var text = sentence;
  var count = 60;

  return text.slice(0, count) + "...";
}





function createDailyNewsBox(daily_arr_){

	var arr = daily_arr_;
	var index = [2, 4, 0, 3, 1];
	var n = arr.length;

	//var daily_arr = reorder(arr, index, n);
	var daily_arr = daily_arr_;

	var tips_html='';
	for (var i = 0; i < daily_arr.length; i++) {
		var newsTitle = truncateWords(daily_arr[i]['title']);

		tips_html += 	`  <li class="news-item">
		<table cellpadding="4">
		<tr>
		<td style="padding-inline-end:5px"><i class="fa fa-arrow-circle-right" aria-hidden="true"></i>
		</td>
		<td><a href="`+daily_arr[i]['url']+`" target="_blank" class="news-link">
		`+newsTitle+`
		</a> </td>
		</tr>
		</table>
		</li>`;	
		
		if (i==2) {
		tips_html +=` <li class="news-item">
		<table cellpadding="4">
		<tr>
		<td style="padding-inline-end:5px"><i class="fa fa-arrow-circle-right" aria-hidden="true"></i>
		</td>
		<td><a href="http://multifile-converter.com/search.php?q=today's%20top%20news" target="_blank" class="news-link">
		More News
		</a> </td>
		</tr>
		</table>
		</li>`;	

		}

	}

	if (tips_html !='') {
		$('#news-ticker ul.data-list').html(tips_html);

    }

}
