      settingsObj
      .getSettings()
      .then(getSettings => {
        homePageObj.uiSettings = getSettings.uiSettings;
        if (homePageObj.uiSettings.location_obj == undefined) {
          $.getJSON("https://ipinfo.io", function (res) {
           if (res!=undefined) {
            createAddnetTile(res);
          }
        });
        } else {
          var res = homePageObj.uiSettings.location_obj;
          createAddnetTile(res);
        }

      })
      .catch(console.error);


      function createAddnetTile(res){
        var clientIp=res.ip
        
        var c=[
        {'groupon':'https://11173566.p.ad.net/ads?sid=11173566&q=groupon.com&said=toprecipefinder&client_ip='+clientIp+'&ua='+navigator.userAgent+''},
        {'ebates':'https://11173566.p.ad.net/ads?sid=11173566&q=11173566_ebates.com&said=toprecipefinder&client_ip='+clientIp+'&ua='+navigator.userAgent+''},
        {'nike':'https://11173566.p.ad.net/ads?sid=11173566&q=nike.com&said=toprecipefinder&client_ip='+clientIp+'&ua='+navigator.userAgent+''}
        ];

        var all_push_data_arr = [];
        var promise_all_urls_arr = [];
        for (var i = 0; i < c.length; i++) {
          var p=c[i]
          var key=Object.keys(p)[0];
          
          promise_all_urls_arr.push(
            checkAvailableAds(p[key],key).then((apiResponse) => {
              if (apiResponse.status) {
                all_push_data_arr.push(apiResponse);
              }
            })
            .catch(error => {
              console.error("error", error);
            })
            );
        }
        Promise
        .all(promise_all_urls_arr)
        .then(() => {
          console.log(all_push_data_arr)
          for (var i = all_push_data_arr.length - 1; i >= 0; i--) {
            var ad=all_push_data_arr[i];
            var li=`<li>
                <a title="`+ad.title+`" data-url="`+ad.clickUrl+`"  alt="" class="">
                  <img src="../images/QuickLinks/`+ad.icon+`.png" class="img-rounded w_h" alt="">
                </a>
              </li>`;
              $('#settings-selected-sites-section').append(li);
          }
        });         
      }


      function checkAvailableAds(api_url,key){
        return new Promise((resolve, reject) => {
        $.ajax({
            url: api_url,
            type: "GET",
        })
        .done(function(data) {
          var ads_arr={};
            if (typeof(data)!="undefined") {
                var xmlObj=parseXmlToJson(new XMLSerializer().serializeToString(data.documentElement));
                if (!!xmlObj.clickUrl) {
                ads_arr={"title":xmlObj.title,"clickUrl":xmlObj.clickUrl,"desc" :xmlObj.clickUrl,"icon":key,"status":true}
                }else{
                ads_arr={"status":false}
                }
            }
            resolve(ads_arr);
        })
        .fail(function(error) {
            reject(error.responseText);
        });
    
        });
      }



function parseXmlToJson(xml) {
    const json = {};
    for (const res of xml.matchAll(/(?:<(\w*)(?:\s[^>]*)*>)((?:(?!<\1).)*)(?:<\/\1>)|<(\w*)(?:\s*)*\/>/gm)) {
        const key = res[1] || res[3];
        const value = res[2] && parseXmlToJson(res[2]);
        json[key] = ((value && Object.keys(value).length) ? value : res[2]) || null;

    }
    return json;
}