var callback=[];
var uiSettings;
var myCalculator={
	load: function(){
		myCalculator.init();
		myCalculator.addEvents()
		myCalculator.getLastStateCalculator();
	},
	onExtMessage: function(message, sender, sendResponse){
		switch (message.command) {

		}
	},
	
	init:function(){
		math.config({
			number: 'BigNumber',  
			precision: 20         
		});	
		myCalculator.display=$( "#display" );
		myCalculator.status=$( "#status" );
		myCalculator.calCfinalValueS='0';
		myCalculator.myCalculatorState={};
		myCalculator.ctNrlDownKey=false;
		myCalculator.shiftDownKey=false;
		myCalculator.ctrlKey=17;
		myCalculator.shiftKey=16;
		myCalculator.vKey=86;
		myCalculator.cKey=67;
		myCalculator.myCalculatorStateList = "myCalculatorState";
	},
	cropText:function(str,n){
		return (str.length > n) ? str.substr(0, n-1) + '&hellip;' : str;
	},
	removeFrom:function(str,index){
		return str.substr(0, index) + str.substr(index+1);
	},
	resultSearchAndTest:function(str,searchPattern){
		var patt = new RegExp(searchPattern);	
		return patt.test(str);
	},
	resultSearchAndReplace:function(str,searchForStr,replaceWithStr){
		return str.replace(new RegExp(searchForStr,"igm"), replaceWithStr);
	},
	calCreset:function (curValue) { 
		$(myCalculator.display).data("number", curValue);
		$(myCalculator.display).data("ismYcalCFunctionPending", false); 
		$(myCalculator.display).data("fromPrevious", false); 
	},
	getCaretCharacterOffsetWithinCalc:function(element){
		var caretOffset = 0;
		if (typeof window.getSelection != "undefined") {
			var range = window.getSelection().getRangeAt(0);
			var preCaretRange = range.cloneRange();
			preCaretRange.selectNodeContents(element);
			preCaretRange.setEnd(range.endContainer, range.endOffset);
			caretOffset = preCaretRange.toString().length;
		} else if (typeof document.selection != "undefined" && document.selection.type != "Control") {
			var textRange = document.selection.createRange();
			var preCaretTextRange = document.body.createTextRange();
			preCaretTextRange.moveToElementText(element);
			preCaretTextRange.setEndPoint("EndToEnd", textRange);
			caretOffset = preCaretTextRange.text.length;
		}
		return caretOffset;
	},
	setmyCalcCaretPos:function(ele, pos){
		try{
			var el = document.getElementById(ele);
			var range = document.createRange();
			var sel = window.getSelection();
			range.setStart(el.childNodes[0], pos);
			range.collapse(true);
			sel.removeAllRanges();
			sel.addRange(range);
		} catch(e) {

		}
	},
	pasteFromClipBoardCalc:function() {
		try {
			var successful = document.execCommand("Paste", false, null);
			var msg = successful ? 'successful' : 'unsuccessful';
			
		} catch (err) {
			
		}
	},
	mykeyDownFromStringCalc:function (computeString) {
		var keymapCalc = [];
		keymapCalc['0'] = 48;
		keymapCalc['1'] = 49;
		keymapCalc['2'] = 50;
		keymapCalc['3'] = 51;
		keymapCalc['4'] = 52;
		keymapCalc['5'] = 53;
		keymapCalc['6'] = 54;
		keymapCalc['7'] = 55;
		keymapCalc['8'] = 56;
		keymapCalc['9'] = 57;
		keymapCalc['x'] = 106;
		keymapCalc['\u00d7'] = 106;
		keymapCalc['/'] = 111;
		keymapCalc['\u00f7'] = 111;
		keymapCalc['+'] = 107;
		keymapCalc['-'] = 109;
		keymapCalc['\u2013'] = 109;
		keymapCalc['.'] = 110;
		keymapCalc['%'] = 112;
		keymapCalc['\u221a'] = 113; 
		keymapCalc['\u00b1'] = 114;
		for (var i = 0; i < computeString.length; i++) {
			var keyPasted = keymapCalc[ computeString[i] ];
			if (typeof keyPasted !== undefined) {
				var e = $.Event('keydown');
				e.which = keyPasted; 
				$("#calculator").trigger(e);
			}
		}
	},
	getLastStateCalculator:function () {
		var calculatorStateStr = localStorage.getItem(myCalculator.myCalculatorStateList);
		try {
			if (calculatorStateStr) {

				myCalculator.myCalculatorState = $.parseJSON(calculatorStateStr);
				$.each(myCalculator.myCalculatorState, function(k, v) {
					v = (typeof v !== "undefined") ? v : "";
					if (k == "display") {
						$(myCalculator.display).text( v );
					}  else if (k == "number") {
						( v !== "") ? $(myCalculator.display).data("number",  v ): $(myCalculator.display).data("number",  0 );
					}  else if (k == "status") {
						$(myCalculator.status).text(v)
					}  else if (k == "calCfinalValueS") {
						myCalculator.calCfinalValueS =  ( v !== "") ? v : 0;
					}  

					else {
						$(myCalculator.display).data(k, v);
					}
				});
				myCalculator.setHistoryofMyCalc();
			} else {
				myCalculator.calCreset(0);
				$(myCalculator.status).text("");
				$(myCalculator.display).text(0);
			}	
		} catch (err) {
			myCalculator.myCalculatorState = {};
		}
	},
	setLastStateMyCalc:function () {
		myCalculator.myCalculatorState.fromPrevious = $(myCalculator.display).data("fromPrevious");
		myCalculator.myCalculatorState.ismYcalCFunctionPending = $(myCalculator.display).data("ismYcalCFunctionPending");
		myCalculator.myCalculatorState.number = $(myCalculator.display).data("number");
		myCalculator.myCalculatorState.status = $(myCalculator.status).text();
		myCalculator.myCalculatorState.display = $(myCalculator.display).text();
		myCalculator.myCalculatorState.calCfinalValueS = myCalculator.calCfinalValueS;
		myCalculator.myCalculatorState.size =  ( $('#resize i').hasClass('glyphicon-resize-full') ) ? "small" : "large",
		myCalculator.myCalculatorState.historyArr = myCalculator.myCalculatorState.historyArr || [];

		localStorage.setItem(myCalculator.myCalculatorStateList, JSON.stringify(myCalculator.myCalculatorState));
	},
	setHistoryofMyCalc:function () {
		$(".calc-history .myCalc-History").each( function(i,h ){
			var liText = ( myCalculator.myCalculatorState.historyArr[i] ) ? myCalculator.myCalculatorState.historyArr[i].display : "";
			if ( liText ) {
				liText = myCalculator.cropText(liText,32);
				$(this).html(liText);
				$(this).removeClass("hidden");
				$(".history").removeClass("hidden");
			} else {
				$(this).addClass("hidden");
			}
		});
	},
	animateItem:function ($ele, val, text) {
		$ele.animate({'opacity': 0
	}, 120, function () {
		if (text)
			$(this).text( val );
		else
			$(this).val( val );
		myCalculator.setLastStateMyCalc();
	}).animate({'opacity': 1
}, 120);
},

addEvents:function(){
	var $calcDisplay=$(myCalculator.display);
	$(".mycalcNum-button").click(function(e){
		e.preventDefault();
		e.stopPropagation();
		var number = $(this).text();
		if ( number == "." ) {
			if ( myCalculator.resultSearchAndTest($calcDisplay.text(),"\\.$"))
				return;	
		}
		if ( $calcDisplay.data("fromPrevious") ) {	
			myCalculator.calCreset(number);
			myCalculator.calCfinalValueS = number;
			$(myCalculator.status).text( "Ans = " + $calcDisplay.text( ) );
			$calcDisplay.text( number)

		} else if ( $calcDisplay.data("ismYcalCFunctionPending")  ) {
			myCalculator.calCfinalValueS += number;			

			$calcDisplay.data("number", number);
			$calcDisplay.text( $calcDisplay.text() + number );
			$calcDisplay.data("ismYcalCFunctionPending", false);

		} else {
			
			var curValue = $calcDisplay.data("number");
			var toAdd = number;	

			if ( $calcDisplay.text() == "0") {
				curValue = "";
				$calcDisplay.text( toAdd );
				myCalculator.calCfinalValueS = toAdd;
			}	else {
				$calcDisplay.text( $calcDisplay.text() + toAdd );
				myCalculator.calCfinalValueS += toAdd;
			}

			var newValue = curValue + toAdd;

			$calcDisplay.data("number", newValue);
				//$display.text(newValue);
			}		
			
			myCalculator.setLastStateMyCalc();
		});
	$(".myCalc-modifier-button").click(function(e){
		e.preventDefault();
		if ( $calcDisplay.data("fromPrevious") ) {
			myCalculator.calCfinalValueS = $calcDisplay.data("number");
			myCalculator.calCreset(myCalculator.calCfinalValueS);

			$(myCalculator.status).text( "Ans = " + $calcDisplay.text( ) );
			$calcDisplay.text( myCalculator.calCfinalValueS )
		}

		try {	
			var modValue = 0
			var number = $calcDisplay.data("number" ).toString()
			if ( number != "") {
				if ($(this).text() == "\u221a") {
					modValue =  math.eval('sqrt('+  number +')');
					$calcDisplay.text( $calcDisplay.text() + "\u221a" );
					var finalValueTmp = myCalculator.calCfinalValueS.toString();
					myCalculator.calCfinalValueS = myCalculator.resultSearchAndReplace(finalValueTmp,number + '$',modValue);

				} else if ( $(this).text() == "\u00b1") {
					if ( number >= 0) {
						modValue = -Math.abs(  number );
						var newStatus = $calcDisplay.text()
						newStatus = newStatus = myCalculator.resultSearchAndReplace(newStatus,number + '$',modValue);

						$calcDisplay.text( newStatus );
						var finalValueTmp = myCalculator.calCfinalValueS.toString();
						myCalculator.calCfinalValueS = myCalculator.resultSearchAndReplace(finalValueTmp,number + '$',modValue);
					} else {
						modValue = Math.abs(  $calcDisplay.data("number") );
						var newStatus = $calcDisplay.text()
						newStatus = myCalculator.resultSearchAndReplace(newStatus,number + '$',modValue);
						$calcDisplay.text( newStatus ) 
						var finalValueTmp = myCalculator.calCfinalValueS.toString();
						myCalculator.calCfinalValueS = myCalculator.resultSearchAndReplace(finalValueTmp,number + '$',modValue);

					}

				} 

				$calcDisplay.data("number", modValue.toString());
			}

		} catch (e) {

		}
		myCalculator.setLastStateMyCalc();

	});



	$(".mYcalC-function-button").click(function(e){
		e.preventDefault();
		e.stopPropagation();
		if ( $calcDisplay.data("fromPrevious") ) {
			myCalculator.calCfinalValueS = $calcDisplay.data("number");
			myCalculator.calCreset(myCalculator.calCfinalValueS);	

			$(myCalculator.status).text( "Ans = " + $calcDisplay.text( ) );
			$calcDisplay.text( myCalculator.calCfinalValueS )
		}

		var pendingFunction = $(this).text();
		var number = $calcDisplay.text().toString();

		if ( !$calcDisplay.data("ismYcalCFunctionPending") ) {
			if (pendingFunction == "+") {
				$calcDisplay.text( number  +  pendingFunction );
				myCalculator.calCfinalValueS += "+";
			} else if (pendingFunction == "\u2013") {
				$calcDisplay.text( number  +   "-" );
				myCalculator.calCfinalValueS += "-";
			} else if (pendingFunction == "\u00d7") {
				$calcDisplay.text( number  +  pendingFunction );
				myCalculator.calCfinalValueS += "*";
			} else if (pendingFunction == "\u00f7") { 
				$calcDisplay.text( number  +  pendingFunction );
				myCalculator.calCfinalValueS += "/" ;
				} else if (pendingFunction == "%") {  // 
					$calcDisplay.text( number  +  pendingFunction );
					myCalculator.calCfinalValueS += "%";
				}		
				$calcDisplay.data("ismYcalCFunctionPending", true);
			}	else {
				if (pendingFunction == "\u2013") {  //minus
					number = myCalculator.resultSearchAndReplace(number,"--","-");
					$calcDisplay.text( number +  "-" );
					myCalculator.calCfinalValueS += "-";
				} 
			}
			myCalculator.setLastStateMyCalc();	
		});
	$(".myCalc-equals-action").click(function(e){
		e.preventDefault();
		e.stopPropagation();
		$('body').scrollTop(0);
		try {
			var finalValueTmp = myCalculator.calCfinalValueS.toString();
			myCalculator.calCfinalValueS = myCalculator.resultSearchAndReplace(finalValueTmp,"([0-9\.]+)%([0-9\.]+)","($2/100)*$1");

			myCalculator.calCfinalValueS =myCalculator.resultSearchAndReplace(myCalculator.calCfinalValueS,"(.*?)([\+-\/\*])([0-9\.]+)%$","($1)$2(($3/100)*($1))");

			var finalValue = math.eval(myCalculator.calCfinalValueS).toString()

			if (typeof finalValue !== "undefined" ) {
				$calcDisplay.data("number", finalValue);
				var display = $calcDisplay.text();
				myCalculator.animateItem($(myCalculator.status), display + "=", true)
				myCalculator.animateItem($calcDisplay, finalValue, true)
				myCalculator.calCreset(finalValue);
				$calcDisplay.data("fromPrevious", true);

				myCalculator.myCalculatorState.historyArr = myCalculator.myCalculatorState.historyArr || [];
				if (!myCalculator.myCalculatorState.fromPrevious) {
					var historyObj =  JSON.parse(JSON.stringify(myCalculator.myCalculatorState));
					delete historyObj.history;
					myCalculator.myCalculatorState.historyArr.unshift(historyObj);
					if (myCalculator.myCalculatorState.historyArr.length > 10) 
						myCalculator.myCalculatorState.historyArr.pop();
					myCalculator.setHistoryofMyCalc();
				}
				myCalculator.setLastStateMyCalc();
			} else {
			}
		} catch (e) {

		}
	});

	$(".myCalc-History").click(function(e){
		e.preventDefault();
		var myCalcHistoryIndex = $('.myCalc-History').index(this);

		$.each(myCalculator.myCalculatorState.historyArr[myCalcHistoryIndex], function(k, v) {
			v = (typeof v !== "undefined") ? v : "";
			if (k == "display") {
				$calcDisplay.text( v );
			}  else if (k == "number") {
				( v !== "") ? $calcDisplay.data("number",  v ): $calcDisplay.data("number",  0 );
			}  else if (k == "status") {
				$(myCalculator.status).text(v)
			}  else if (k == "calCfinalValueS") {
				myCalculator.calCfinalValueS =  ( v !== "") ? v : 0;
			}  else if (k == "addToHome") {
				addToHome =  ( v !== "") ? parseInt(v) : 0;
			}  else {
				$calcDisplay.data(k, v);
			}
		});
	});

	$(".myCalc-clear").click(function(e){ 	
		e.preventDefault();
		e.stopPropagation();
		myCalculator.calCreset(0);  
		$calcDisplay.text(0) 
		$(myCalculator.status).text("");
		myCalculator.calCfinalValueS = "0";
		myCalculator.setLastStateMyCalc();
		$('body').scrollTop(0);
	});
	$(".myCalc-clear-history").click(function(e){
		e.preventDefault();
		myCalculator.myCalculatorState.historyArr = [];
		myCalculator.setLastStateMyCalc();
		myCalculator.setHistoryofMyCalc();
	});
	$(myCalculator.status).on('keydown', function(e) {
		switch ( e.keyCode ) {
			case 39:
			$(myCalculator.status).animate({scrollLeft: '+=50' }, 100)
			break;
			case 37:
			$(myCalculator.status).animate({scrollLeft: '+=50' }, 100)
			break;
		}
	});
	$(myCalculator.display).on('keydown', function(e) {
		e.preventDefault();

		try {
			switch (e.keyCode ) {
				case 39:
				var caretPos = myCalculator.getCaretCharacterOffsetWithinCalc(document.getElementById("display"));
				var offset = caretPos+1
				if (offset <= $display.text().length) 
					myCalculator.setmyCalcCaretPos("display", offset);
				break;
				case 37:
				var caretPos = getCaretCharacterOffsetWithinCalc(document.getElementById("display"));
				var offset = caretPos-1
				if (offset >=0) 
					myCalculator.setmyCalcCaretPos("display", offset);
				break;
				case ctrlKey:
				myCalculator.ctNrlDownKey = true;
				break;
				case shiftKey:
				myCalculator.shiftDownKey = true;
				break;
			}
		} catch(e) {
		}
	}).keyup(function(e) {
		if (e.keyCode == myCalculator.ctrlKey) 
			myCalculator.ctNrlDownKey = false;
		if (e.keyCode == myCalculator.shiftKey) 
			myCalculator.shiftDownKey = false;
	}); 


	$(document).on('keydown', function(e) {
		
		if ($('#calc-modal').css('display')=='none') {
			return 
		} 
		e.preventDefault();
		e.stopPropagation();
		$('.hoverClass').removeClass('hoverClass');
		switch ( e.which ) {
			case 13:
			$(".myCalc-equals-action").addClass("hoverClass");
			$(".myCalc-equals-action").trigger("click");
			setTimeout(function(){
				$(".myCalc-equals-action").removeClass('hoverClass');
			},300)
			break;
			case 187:
			if (myCalculator.shiftDownKey) {
				$(".add").addClass("hoverClass");
				$(".add").trigger("click");
				setTimeout(function(){
					$(".add").removeClass('hoverClass');
				},300)
			}
			else{
				$(".myCalc-equals-action").addClass("hoverClass");
				$(".myCalc-equals-action").trigger("click");
				setTimeout(function(){
					$(".myCalc-equals-action").removeClass('hoverClass');
				},300)
			}
			break;
			case myCalculator.ctrlKey:
			myCalculator.ctNrlDownKey = true;
			break;
			case myCalculator.shiftKey:
			myCalculator.shiftDownKey = true;
			break;
			case 106:
			$(".multiply").addClass("hoverClass");
			$(".multiply").trigger("click");
			setTimeout(function(){
				$(".multiply").removeClass('hoverClass');
			},300)
			break;
			case 111:
			case 191:
			$(".divide").addClass("hoverClass");
			$(".divide").trigger("click");
			setTimeout(function(){
				$(".divide").removeClass('hoverClass');
			},300)
			break;
			case 107:
			$(".add").addClass("hoverClass");
			$(".add").trigger("click");
			setTimeout(function(){
				$(".add").removeClass('hoverClass');
			},300)

			break;
			case 109:
			case 189:	
			$(".subtract").addClass("hoverClass");
			$(".subtract").trigger("click");
			setTimeout(function(){
				$(".subtract").removeClass('hoverClass');
			},300)

			break;
			case 110:
			case 190:
			$(".dot").addClass("hoverClass");
			$(".dot").trigger("click");
			setTimeout(function(){
				$(".dot").removeClass('hoverClass');
			},300)

			break;
			case 96:
			case 48:
			$(".zero").addClass("hoverClass");
			$(".zero").trigger("click");
			setTimeout(function(){
				$(".zero").removeClass('hoverClass');
			},300)
			break;
			case 97:
			case 49: 
			$(".one").trigger("click");
			$(".one").addClass("hoverClass");
			setTimeout(function(){
				$(".one").removeClass('hoverClass');
			},300)
			break;
			case 98:
			case 50: 
			$(".two").addClass("hoverClass");
			$(".two").trigger("click");
			setTimeout(function(){
				$(".two").removeClass('hoverClass');
			},300)
			break;
			case 99:
			case 51:
			$(".three").addClass("hoverClass");
			$(".three").trigger("click");
			setTimeout(function(){
				$(".three").removeClass('hoverClass');
			},300)
			break;
			case 100:
			case 52:
			$(".four").addClass("hoverClass");
			$(".four").trigger("click");
			setTimeout(function(){
				$(".four").removeClass('hoverClass');
			},300)

			break;
			case 101:
			case 53:
			if (myCalculator.shiftDownKey) {
				$(".percent").addClass("hoverClass");
				$(".percent").trigger("click");
				setTimeout(function(){
					$(".percent").removeClass('hoverClass');
				},300)
			}
			else{

				$(".five").addClass("hoverClass");
				$(".five").trigger("click");
				setTimeout(function(){
					$(".five").removeClass('hoverClass');
				},300)
			}
			break;
			case 102:
			case 54:
			$(".six").addClass("hoverClass");
			$(".six").trigger("click");
			setTimeout(function(){
				$(".six").removeClass('hoverClass');
			},300)
			break;
			case 103:
			case 55:
			$(".seven").addClass("hoverClass");
			$(".seven").trigger("click");
			setTimeout(function(){
				$(".seven").removeClass('hoverClass');
			},300)
			break;
			case 104:
			case 56:
			if (myCalculator.shiftDownKey){

				$(".multiply").addClass("hoverClass");
				$(".multiply").trigger("click");
				setTimeout(function(){
					$(".multiply").removeClass('hoverClass');
				},300)	
			}
			else{
				$(".eight").addClass("hoverClass");
				$(".eight").trigger("click");
				setTimeout(function(){
					$(".eight").removeClass('hoverClass');
				},300)
			}

			break;
			case 105:
			case 57:
			$(".nine").addClass("hoverClass");
			$(".nine").trigger("click");
			setTimeout(function(){
				$(".nine").removeClass('hoverClass');
			},300)

			break;
			case 112:
			$(".percent").addClass("hoverClass");
			$(".percent").trigger("click");
			setTimeout(function(){
				$(".percent").removeClass('hoverClass');
			},300)

			break;
			case 113:
			$(".squareroot").addClass("hoverClass");
			$(".squareroot").trigger("click");
			setTimeout(function(){
				$(".squareroot").removeClass('hoverClass');
			},300)

			break;
			case 114:
			$(".plusminus").addClass("hoverClass");
			$(".plusminus").trigger("click");
			setTimeout(function(){
				$(".plusminus").removeClass('hoverClass');
			},300)

			break;						
			case 8:
			$('#display').focus();
			var caretPos = myCalculator.getCaretCharacterOffsetWithinCalc(document.getElementById("display"));

			var newString =  myCalculator.removeFrom($(myCalculator.display).text(),caretPos-1, ""); 
			$(".myCalc-clear").addClass("hoverClass");
			$(".myCalc-clear").trigger('click');
			setTimeout(function(){
				$(".myCalc-clear").removeClass('hoverClass');
			},300)

			myCalculator.mykeyDownFromStringCalc(newString);
			if (caretPos-1 >=0) 
				myCalculator.setmyCalcCaretPos("display", caretPos-1);
			break;						
			case 46: 
			$('#display').focus();
			var caretPos = myCalculator.getCaretCharacterOffsetWithinCalc(document.getElementById("display"));
			myCalculator.setmyCalcCaretPos("display", caretPos);

			var newString =  myCalculator.removeFrom($(myCalculator.display).text(),caretPos, ""); 
			$(".myCalc-clear").addClass("hoverClass");
			$(".myCalc-clear").trigger('click');
			setTimeout(function(){
				$(".myCalc-clear").removeClass('hoverClass');
			},300)
			myCalculator.mykeyDownFromStringCalc(newString);
			if (caretPos >=0) 
				myCalculator.setmyCalcCaretPos("display", caretPos);
			break;
			case 86:
			if (myCalculator.ctNrlDownKey) {
				myCalculator.pasteFromClipBoardCalc()
			}
			break;
			case 67:	
			if (myCalculator.ctNrlDownKey) {
				try {
					var successful = document.execCommand('copy');
					var msg = successful ? 'successful' : 'unsuccessful';

				} catch (err) {

				}
			} else {
			$(".myCalc-clear").addClass("hoverClass");

				$(".myCalc-clear").trigger('click')
				setTimeout(function(){
				$(".myCalc-clear").removeClass('hoverClass');
			},300)
			}

			break;
			default:

			break;
		}
	}).keyup(function(e) {
		if (e.keyCode == myCalculator.ctrlKey) 
			myCalculator.ctNrlDownKey = false;
		if (e.keyCode == myCalculator.shiftKey) 
			myCalculator.shiftDownKey = false;
	});

	document.onpaste = function(event) {
		if (!!event.target.closest('.modal-content') || !!event.target.closest('.form-inline')) {
			return;
		}
		var clipboardText = event.clipboardData.getData("Text");
		if ( !isNaN(clipboardText) ) {
			$(myCalculator.display).text( clipboardText )
			myCalculator.calCreset(clipboardText);
			myCalculator.calCfinalValueS = clipboardText;
		}
		event.preventDefault();
	};

}
}
function sendMessage(msg, callbackfn) {
	if(callbackfn!=null) {
		callback.push(callbackfn);
		msg.callback = "yes";
	}
	chrome.runtime.sendMessage(msg,callbackfn);
}
chrome.runtime.onMessage.addListener(myCalculator.onExtMessage);

window.addEventListener("load",function() {
	myCalculator.load();
});


function sendMessage(msg, callbackfn) {
	if(callbackfn!=null) {
		msg.callback = "yes";
	}
	chrome.runtime.sendMessage(msg,callbackfn);
}

