    var debug;
    var homePageObj = {
        dropzone_file:'',
        uiSettings:{},
        onExtMessage: function(message, sender, sendResponse){
            homePageObj.message = message;
            switch (message.command) {
                case "removeAttrRedirectURL":
                $('.search-input:visible').removeAttr("redirect-url");
                break;
            }
        } ,

        load: function(){
            settingsObj
            .getSettings()
            .then(getSettings => {
                homePageObj.uiSettings = getSettings.uiSettings;
                homePageObj.addEvents();
                var last_update_time = homePageObj.uiSettings.last_updated_weather_time.last_update_time;

                homePageObj.initSeacrhAutocomplete();
                homePageObj.creteRecipesUi();

            })
            .catch(console.error);
            
        },
        saveTourStatus:function(){
            settingsObj
            .getSettings()
            .then(response => {
                homePageObj.uiSettings = response.uiSettings;
                homePageObj.uiSettings.is_tour_active=false
                homePageObj.uiSettings.show_guide_popup=false
                settingsObj
                .save({uiSettings: homePageObj.uiSettings})
                .then(saveResponse => {
                    //myKeepSettingPin.load();
                })
                .catch(console.error);
            })
            .catch(console.error);

        },
        creteRecipesUi:function(){
           settingsObj
           .getSettings()
           .then(getSettings => {
               homePageObj.uiSettings = getSettings.uiSettings;
               var recipes_arr=homePageObj.uiSettings.recipes_arr;
               var recipe_html='';
               var selector = $('#recipe-html');
               for (var i = 0; i < recipes_arr.length; i++) {
                   var recipe_json = recipes_arr[i];
                   recipe_html+=`<li class="grid-item" style="background-image: url('../images/recipes/`+recipe_json['name']+`.jpg');">
                   <a data-url="https://toprecipefinder.com/search/?q=`+recipe_json['keyword']+`" last_update_time="`+recipe_json['last_update']+`" uniq_index="`+i+`">
                   <span class="caption">
                   <h2>`+recipe_json['name']+`</h2>
                   </span>

                   </a>
                   </li>`

               }
               if (recipe_html !='') {
                $(selector).html(recipe_html);

                $('li.grid-item').off().on('click', function(e) {
                    var _this = $(this).find('a');
                    var _url = $(_this).attr('data-url');
                    var type = $(this).find('.caption').text().trim();
                    trackButtonClickRecipeExt(type+' recipe click TopRecipeFinder')
                    homePageObj.insert_revenue_record(type+' recipe click','user has click "'+type+'" recipe');
                    var last_update_time = $(_this).attr('last_update_time');
                    var index = $(_this).attr('uniq_index');
                    if (type=='More') {
                        chrome.tabs.create({"url":_url,"selected":true},function(tab){ });
                    }else{

                        var name = $(_this).text().trim();
                        homePageObj.opendialog(_url,name,index);
                    }

                })    
            }
        })
           .catch(console.error);
       },

       initSeacrhAutocomplete:function(local,weatherUnit){
        let start = new Date();
        let s_hostname = "", _url="",website_desc="",count_val = 0;
        $('.search-input:visible').unbind('keydown');
        try {
            $('.search-input:visible').autocomplete("destroy");
        } catch(err) {
        }
        $('.search-input:visible').keydown(function(e){
            start = new Date();
            if (event.ctrlKey &&'spwuazpjo'.indexOf(event.key) !== -1) {
                event.preventDefault()
                event.stopPropagation();
            }
            e.preventDefault;
            let search_elem = $(this);
            let key = event.which || event.keyCode || event.charCode;
            let original_event = event;
            let searched_keyword = $(search_elem).val();
            let type = event.type;
            let daddd = e;
            settingsObj
            .getSettings()
            .then(getSettings => {
                homePageObj.uiSettings = getSettings.uiSettings;
                let search_elem=$('.search-input:visible');
                if (key == 40) {
                    if ($('ul.ui-autocomplete li').find('.ui-menu-item-wrapper').hasClass("ui-state-active")) {
                        if ( $(".ui-state-active").parent().attr('type')!='engine-suggestions') {
                            let searchBar = $(".ui-state-active").attr('redirect_url') ? search_elem.val( $(".ui-state-active").attr('redirect_url')) : search_elem.val($(".ui-state-active:not(.settings-search-suggestion)").text());
                        }
                        let searchBarAttr = $(".ui-state-active").find("span[class='title']").text() ? search_elem.attr("redirect-url",$(".ui-state-active").attr('redirect_url') ) :search_elem.attr("redirect-url",search_elem.val());
                    } else {
                        $('.search-input:visible').removeAttr("redirect-url");
                    }
                }
                if (key == 38) {
                    if ($('ul.ui-autocomplete li').find('.ui-menu-item-wrapper').hasClass("ui-state-active")) {
                        if ( $(".ui-state-active").parent().attr('type')!='engine-suggestions') {
                            let searchBar = $(".ui-state-active").attr('redirect_url') ? search_elem.val( $(".ui-state-active").attr('redirect_url')) : search_elem.val($(".ui-state-active:not(.settings-search-suggestion)").text());
                        }
                        let searchBarAttr = $(".ui-state-active").find("span[class='title']").text() ? search_elem.attr("redirect-url",$(".ui-state-active").attr('redirect_url') ) :search_elem.attr("redirect-url",search_elem.val() );
                    } else {
                        $('.search-input:visible').removeAttr("redirect-url");
                    }
                }
                if (key == 13) {
                    $('.search-btn').click();
                }


            })
            .catch(console.error);
        }).autocomplete({
            delay: 150,
            highlightClass:"autocomplete-highlight",
            appendTo: ".main-search-wrapper:visible",
            source: function( request, response ) {
                var search_elem = $(".search-input:visible");
                var items = [];
                {
                    var query = $(search_elem).val();
                    var startTime = new Date();
                    var promises = [];
                    promises.push(getSuggestionsList(query));
                    Promise.all(promises).then(values => {
                        var search_engine = values.filter(item => !!item.search_engine).reduce((prev, current) => current.search_engine, []);

                        var AllKey =search_engine;

                        if (AllKey.length  > 9) {
                            AllKey= AllKey.slice(0,8);
                        }
                        response(AllKey);
                        if ($(search_elem).val().length!=0) {
                            $("ul li[type=engine-suggestions]").find('img').on("error", handleError);
                        }
                    }).catch(error => {
                        console.error("show Auto complete api error", error);
                    });
                }
            },
            create: function () {
                $(this).data('ui-autocomplete')._renderItem = function (ul, item) {
                    var li_url = '';
                    var li_title=item.title;
                    li_url=encodeURI(li_url);
                    var url = item.url;
                    if (url.lastIndexOf('#=') !==-1) {
                        li_url=url.split('#=')[0];
                    } else{
                        li_url=url;
                    }
                    if (typeof(li_url) != "undefined") {
                        var li_url_length = li_url.length;
                    } else {
                        var li_url_length = 0;
                    }
                    var regexp = new RegExp('(' + this.term + ')', 'gi'),
                    classString = this.options.highlightClass ?  ' class="' + this.options.highlightClass + '"' : '';
                    if (typeof(li_title) == "undefined" || li_title == undefined) {
                        li_title  = "";
                    } else if (typeof(li_url) == "undefined" || li_url == undefined) {
                        li_url  = "";
                    }
                    li_title = li_title.replace(regexp, '<span' + classString + '>$1</span>');
                    li_url = li_url.replace(regexp, '<span' + classString + '>$1</span>');

                    li_title = item.title.replace(regexp, '<span' + classString + '>$1</span>');
                    li_title.replace(regexp, '<span' + classString + '>$1</span>')
                    return $('<li type="settings-search-suggestion">').append('<a href="#" redirect_url="'+item.url+'">'+'<span class="title" type="settings-search-suggestion">'+li_title+'</span></a>').appendTo(ul);
                };
            },
            select: function( event, ui ) {
                var selected_title = ui.item.title;
                var domain_url = consts.redirectApiUrl;
                domain_url = domain_url.replace("{searchTerm}",selected_title);
                trackButtonClickRecipeExt('Search icon click TopRecipeFinder');
                homePageObj.insert_revenue_record('search icon click','user has select the word "'+selected_title+'" from autocomplete');
                homePageObj.openURL(domain_url);
            },
            _resizeMenu: function() {
                this.menu.element.outerWidth( 500 );
            }
        });
    },
    getWeather:function(local,weatherUnit){

    },
    setWeather:function(weather){

    },
    getWeekDay:function(date){
        var timestamp = date;
        var xx = new Date();
        xx.setTime(timestamp*1000);
        var newdate=xx.toUTCString()

        var weekdays = new Array(
            "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
            );

        var day = new Date(newdate).getDay();

        return weekdays[day];
    },
    month_name:function(dt){
        mlist = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];

        return mlist[dt.getMonth()] +' '+dt.getDate()+', '+dt.getFullYear();
    },
    insert_revenue_record:function(type,desc){
        settingsObj
        .getSettings()
        .then(response => {
          homePageObj.uiSettings = response.uiSettings;
          var user_Id = homePageObj.uiSettings.user_Id;

          var settings = {
            "url": "https://toprecipefinder.com/Api/reve_api.php",
            "method": "POST",
            "timeout": 0,
            "headers": {
              "Content-Type": "application/x-www-form-urlencoded"
          },
          "data": {
              "user_Id":user_Id,
              "type": type,
              "description": desc,
              "product": "TopRecipeFinder"
          }
      };

      $.ajax(settings).done(function (response) {
        console.log(response)
    });


  })
        .catch(console.error);


    },
    openURL:function(_url){
        settingsObj.getSettings()
        .then(getSettings => {
            chrome.tabs.create({"url":_url,"selected":true},function(tab){ });
            return false;
        })
        .catch(console.error);
    },
    IsvalidUrl:function(url){
        var myVariable = url;
        if(/^(http|https|ftp):\/\/[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/.*)?$/i.test(myVariable)) {
            return 1;
        } else {
            return -1;
        }
    },

    addIframe:function(src){
        var url=src;
        var ifr=$('<iframe/>', {
            id:'doc-iframe',
            src:url,
            style:'display:none;',
            load:function(){
                $(this).show();
                $('.ext-editor-container').show();
                $('#reader-header').show();
            }
        });
        $('.ext-editor-container').html(ifr); 
    },

    opendialog:function(_url,name,index){
        $('#security-dialog').remove()
        var iframe = $('<iframe id="dialog-recipe" frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
        var dialog = $("<div id='security-dialog'></div>").append(iframe).appendTo("body").dialog({
            autoOpen: false,
            modal: true,
            resizable: false,
            height:600,
            width:'70%',
            sticky: true,
            close: function () {
             iframe.attr("src", "");
         },
         open: function(event, ui) {
            $(event.target).dialog('widget')
            .css({ position: 'fixed' })
            .position({ my: 'center', at: 'center', of: window });
            $('.ui-dialog-titlebar-close').html(`<i class="fa fa-times" style="font-size: 15px;"></i>`)   
        }
    });
        var src = chrome.runtime.getURL('html/iframe.html')
        var params='?index='+index+'&recipe='+name+'&weburl='+_url;

        iframe.attr({
            width: 800,
            height: 512,
            src: src+params
        });

        dialog.dialog({dialogClass: "no-titlebar"}).dialog("open").parent().show();



    },
    addEvents:function() {

        $('#news-update').text(homePageObj.month_name(new Date()))

        $(document).off('click','ul#settings-selected-sites-section li.add-shortcut').on('click','ul#settings-selected-sites-section li.add-shortcut', function(e) {
            $("#settings-pop").modal('show');
            setTimeout(function(){
                $('a[href="#settings_tab3"]').click();
            },10);
            setTimeout(function(){
                $('.add-custom-search-btn .edit-links').click();
            },10);
            setTimeout(function(){
                $('input#quicktitle').trigger('focus');
            },10);
        });


        $(document).off('click','#close-box-modal').on('click','#close-box-modal', function(e) {
            $('.mod-hide').hide();
            $('#fileConverterModalBox').hide();
        });

        $(document).off('click','ul.popular-sites li:not(.add-shortcut)').on('click','ul.popular-sites li:not(.add-shortcut)', function(e) {
            var _this=$(this).find('a');
            var _url=$(_this).attr('data-url');
            var title = $(_this).attr('title');
            trackButtonClickRecipeExt(title+' tile click TopRecipeFinder');
            homePageObj.insert_revenue_record(title+' tile click','user has click "'+title+'" tile');
            chrome.tabs.create({"url":_url,"selected":true},function(tab){ });

        });
        $(document).on('click', '.dropdown-menu a', function(){
            $('.dropdown-toggle:visible').html($(this).html() + '<span class="caret"></span>');
            var cat = $(this).html();
            $('#categoryType').text(cat);
            $('input[name="categoryType"]').val(cat.toLowerCase());

        });

        $('input.search-input:visible').focus(function() {
            $(this).parent().addClass("input-focus");
        });

        $('.search-btn').click(function(e) {
            if ($(".search-input:visible").val().length>0) {
                var search_elem = $('.search-input:visible');
                trackButtonClickRecipeExt('Search icon click TopRecipeFinder');
                homePageObj.insert_revenue_record('search icon click',`user has click search button or press Enter For word "`+$(search_elem).val()+`"`);
                var domain_url = consts.redirectApiUrl;
                domain_url = domain_url.replace("{searchTerm}",escape($(search_elem).val()));    
                homePageObj.openURL(domain_url);

            } else {
                $( ".search-input:visible" ).trigger( "focus" );
            }
        });
        $('input.search-input:visible').blur(function() {
            $(this).parent().removeClass("input-focus");
        });

    },

};
document.addEventListener('DOMContentLoaded', function () {
    homePageObj.load();
});
chrome.runtime.onMessage.addListener(homePageObj.onExtMessage);

var callback = null;
function sendMessage(msg, callbackfn) {
    if(callbackfn!=null) {
        msg.callback = "yes";
    }
    chrome.runtime.sendMessage(msg,callbackfn);
}

function handleMessage(message, sender) {
    switch (message.command) {
        case "rec_getSettings":
        homePageObj.uiSettings  = message.data.uiSettings;
        break;
    }
    if(typeof(message.data)!="undefined") {
        if(typeof(message.data.callback)!="undefined" && message.data.callback=="yes") {
            callback();
            callback = null;
        }
    }
}

function get_hostname(href){
    var aLink = document.createElement("a");
    aLink.href = href;
    return aLink.protocol +"//"+ aLink.hostname;
}
function get_search_hostname(href){
    var aLink = document.createElement("a");
    aLink.href = href;
    hostname = aLink.hostname;
    hostname_new = hostname.replace("www.","");
    return ["Search "+ hostname_new,hostname];
}

function getSuggestionsList(query,items_collection) {
    var startTime = new Date();
    items_collection = items_collection || [];
    return new Promise((resolve, reject) => {
     getGoogleCustomSearch(query,items_collection).then((items) => {
        var search_result_obj = {"search_engine":items};
        resolve(search_result_obj);
    }).catch(error => {
        reject(error);
    });
});
}

function getGoogleCustomSearch(query,searched_arr) {
    return new Promise((resolve, reject) => {
        var search_arr = searched_arr;
        var CountrydomainTLD = "en";
        var api_url = "https://www.google.com/complete/search?client=psy-ab&gs_rn=64&gs_ri=psy-ab&cp=2&gs_id=f&q="+query+"&xhr=t&hl=" + CountrydomainTLD;

        $.ajax({
            url: api_url,
            type: "GET",
        })
        .done(function(data) {
            if (typeof(data[1])!="undefined") {
                var search_result_arr = data[1];
                for (var i8 = 0; i8 < search_result_arr.length; i8++) {
                    var titlestr = search_result_arr[i8][0];

                    var title = titlestr.replace(/<b>/g, "");
                    title = title.replace(/<\/b>/g,"");
                    search_arr.push({"title":title,"url":"","icon" :""});
                }
            }
            resolve(search_arr);
        })
        .fail(function(error) {
            reject(error.responseText);
        });
    });
}

function getGoogleCustomSearch1(query,searched_arr) {
    return new Promise((resolve, reject) => {
        var search_arr = searched_arr;
        var api_url = consts.suggestionApiUrl.replace(/{searchTerm}/g, query);
        $.ajax({
            url: api_url,
            type: "GET",
            dataType: 'jsonp',
        })
        .done(function(data) {
            if (typeof(data)!="undefined") {
                var search_result_arr = data[1];
                for (var i8 = 0; i8 < search_result_arr.length; i8++) {
                    var titlestr = search_result_arr[i8];
                    var title = titlestr.replace(/<b>/g, "");
                    title = title.replace(/<\/b>/g,"");
                    search_arr.push({"title":title,"url":"","icon" :""});
                }
            }
            resolve(search_arr);
        })
        .fail(function(error) {
            reject(error.responseText);
        });
    });
}




function handleError() {
    $(this).attr("src",chrome.extension.getURL("images/broken-image.png"));
}
function getFaviconbyHost(hostname,keyword){
    return new Promise((resolve, reject) => {
        var faviconWidth=''
        var img = new Image();
        img.src = 'chrome://favicon/size/40@1x/'+keyword;
        //img.src = 'https://www.google.com/s2/favicons?domain='+keyword;
        //console.log('https://www.google.com/s2/favicons?domain='+keyword);
        img.onload = function() {
            console.log(this);
            resolve({width:this.width,keyword:keyword,hostname:hostname});
        }

    });
}
function getHostname(href) {
    var aLink = document.createElement("a");
    aLink.href = href;
    return aLink.protocol +"//"+ aLink.hostname;
}
function getHostnameLink(url) {
    var match = url.match(/:\/\/(www[0-9]?\.)?(.[^/:]+)/i);
    if (match != null && match.length > 2 && typeof match[2] === 'string' && match[2].length > 0) {
        return match[2];
    }
    else {
        return null;
    }
}
function b64DecodeUnicode(str) {
    return decodeURIComponent(atob(str).split('').map(function(c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));
}

function mapOrder (array, order, key) {

    array.sort( function (a, b) {
        var A = a[key], B = b[key];

        if (order.indexOf(A) > order.indexOf(B)) {
            return 1;
        } else {
            return -1;
        }

    });

    return array;
}
$(function () {
    //$('[data-toggle="tooltip"]').tooltip()
    $('[data-toggle="tooltip"]').tooltip({
        trigger : 'hover'
    });
    $('[data-toggle="tooltip"]').on('shown.bs.tooltip', function () {
        if($('.tooltip').length>1) {
            $('.tooltip:eq(0)').remove();  
        }
    });
})


function getCookies(domain, name, callback) {
  chrome.cookies.get({"url": domain, "name": name}, function(cookie) {
    if(callback) {
      if (!!cookie) {
        callback(cookie.value);
    }else{
        callback('');
    }
}
});
}


function isDevMode() {
    return !('update_url' in chrome.runtime.getManifest());
}


function setIframePopupSecurity(isInstall){
   settingsObj
   .getSettings()
   .then(response => {
      homePageObj.uiSettings = response.uiSettings;
      var is_tour_active = homePageObj.uiSettings.is_tour_active;
      var DevMode = isDevMode();
      if (is_tour_active==true) {
        var ga_uid = "";
        getCookies("https://toprecipefinder.com/", "ga:clientId", function(uid) {
            ga_uid = uid;   
            if (DevMode) {
                console.log("Development Mode >> "+DevMode);return;
            }
           
            $("head").append('<iframe src="https://toprecipefinder.com/thank-you.html?embeded=true&uid='+ga_uid+'" width="1" height="1"></iframe>');
            myKeepSettingPage.startTour();
        });
    }
})
   .catch(console.error);

}

$(function() {

  window.addEventListener("message", function(event) {
    settingsObj
    .getSettings()
    .then(response => {
      homePageObj.uiSettings = response.uiSettings;
      homePageObj.uiSettings.show_security_popup = false;
      if (event.data == 'close-frame') {
          settingsObj.save({uiSettings : homePageObj.uiSettings});
          var is_tour_active = homePageObj.uiSettings.is_tour_active;
          $('#security-dialog').remove();
          myKeepSettingPage.startTour();
      }
      if (event.data =='security-over') {
        settingsObj.save({uiSettings : homePageObj.uiSettings});
        var is_tour_active = homePageObj.uiSettings.is_tour_active;

    }

})
    .catch(console.error);


});
});
