window.addEventListener("load",function() {
  chrome.runtime.onMessage.addListener(handleMessage);
  
});
var is_started_tour=false;
var uiSettings;
var myKeepSettingPin = {
  uiSettings: {},
  load: function(){ 
    myKeepSettingPin.addEvents();

    settingsObj
    .getSettings()
    .then(response => {
      myKeepSettingPin.uiSettings = response.uiSettings;
      if (myKeepSettingPin.uiSettings.show_keep_setting_popup_pin == undefined) {
        myKeepSettingPin.uiSettings.show_keep_setting_popup_pin = true;
      }
      var show_keep_setting_popup_pin = myKeepSettingPin.uiSettings.show_keep_setting_popup_pin;
      if (show_keep_setting_popup_pin == true ) {
        $(".mfc-keep-settings-section-pin").show();
        //$(".mfc-keep-settings-section-pin-pin").show();
        setTimeout(function(){
        $("#mfc-section-overlay-pin").addClass("fade-out");
          setTimeout(function(){
           myKeepSettingPin.saveKeepSetting();
          }, 800);
        }, 10000);
      }
    })
    .catch(console.error);
  },
  addEvents: function(){
    $(document).on('click', '.mfc-keep-settings-backdrop-section', function(e){
      e.preventDefault();
         myKeepSettingPin.saveKeepSetting();
    });
  },
  saveKeepSetting: function(){
    settingsObj
    .getSettings()
    .then(response => {
      myKeepSettingPin.uiSettings = response.uiSettings;
      myKeepSettingPin.uiSettings.show_keep_setting_popup_pin = false;
      settingsObj.save({uiSettings : myKeepSettingPin.uiSettings});
      $(".mfc-keep-settings-section-pin").hide();
      
    })
    .catch(console.error);
  }
};

var callback=[];
function sendMessage(msg, callbackfn) {
  if(callbackfn!=null) {
    callback.push(callbackfn);
    msg.callback = "yes";
  }
  chrome.runtime.sendMessage(msg,callbackfn);
}

function handleMessage(message, sender) {
  switch (message.command) {
    case "rec_getSettings":
    myKeepSettingPin.uiSettings  = message.data.uiSettings;
    myKeepSettingPin.smsSettings = message.data.smsSettings;
    break;
  }
  if(typeof(message.data)!="undefined") {
    if(typeof(message.callback)!="undefined" && message.callback=="yes") {
      var fun = callback.pop();
    }
  }
}